/****************************************************************************
*    Copyright (c) 1999 CASEMaker Inc.                                      *
*    http://www.dbmaker.com  http://www.dbmaker.com.tw                      *
*    You may distribute under the terms of the GNU General Public License.  *
*                                                                           * 
*    build.c                                                                *
*    CGI program which are used to set property attribute of web search.    *
*****************************************************************************/
#include "webut.h"
#include "dmwebut.h"
#include "mmhtml.h"

DWitem  item[MAX_ITEMS];    /* used to get CGI string name and value */
int     total_item;

HENV    henv;
HDBC    hdbc;
HSTMT   hstmt;
SDWORD  cbcontent=SQL_DATA_AT_EXEC; /* size of file content in one block, 
                                       we put total content block by block */
SDWORD  cbfobj   =SQL_NTS;  /* size of file object */
SDWORD  cbtitle  =SQL_NTS;  /* size of HTML title */
SDWORD  cbftime  =SQL_NTS;  /* size of file time record */
int     num      =0;        /* represent serial number of inserted data */
char    fobj[LEN_FNAME];    /* file object */
char    title[LEN_TITLE];   /* HTML title of file object */

/**********************************************************************
*  static functions prototype for web administrator
***********************************************************************/
static int proWebAdm(char *sdPath, char *extNames, char *fdPath, int recurse,
                     char *tFile, int log, int hitP, int weight, char *passwd,
                     char *preTag, char *endTag, char *version, 
                     char *homeDir, char *tempDir);
                     
static void findAndInsert(char *dirName, char *extName[], int cExt, 
                          char *forbidDir[], int cForbid, int recurse);

static void processFile(char *extName, char *fname, struct stat statbuf);

static void insertPath(char *searchDir[], int cSearch, char *extName[], int cExt, 
                    char *forbidDir[], int cForbid, char *tFile, 
                    char *homeDir, char *tempDir);
static void insertWebPage(char *searchDir[], int cSearch, char *extName[],int cExt, 
                       char *forbidDir[], int cForbid, int recurse);
static void insertOutput(char *tFile);
static void insertParams(char *preTag, char *endTag, int hitP, int weight, 
                      int log, int recurse, char* version);

/****************************************************************************
 Main function 
 ****************************************************************************/
void main()
{
  char sdPath[LEN_PATHS];   /* string to record path of search directories */
  char fdPath[LEN_PATHS];   /* string to recrod path of forbidden directories */
  char ext[LEN_EXT];        /* record filename extensions user want to search */
  char template[LEN_FNAME]; /* template file location */
  char passwd[LEN_PWD];     /* password of user to connect to database */
  char preTag[LEN_TAG];     /* preTag to add in front of searched pattern */
  char endTag[LEN_TAG];     /* endTag to add in back of searched pattern */
  char version[LEN_HTML];   /* language version */
  char homeDir[LEN_FNAME];  /* homepage directory */  
  char tempDir[LEN_FNAME];  /* temp directory to put temporary file */
  int  hitPerP=INI_HIP;     /* hit count per page */
  int  weight=INI_WGT;      /* weight of title */
  int  recurse=INI_REC;     /* whether recursively process sub-directory */
  int  log=INI_LOG;         /* whether log operation of web client */
  int  total;               /* total count of inserted data */
  int  i;                   /* just used for count */
    
  DWGetItem();

  printf("Content-type: text/html\n\n");
  
  printf("<html><head>");
  printf("<meta http-equiv=Content-Type content=\"text/html; charset=big5\">\n");  
  printf("<script language=\"javascript\"></script>");
  printf("<title>Begin to insert data and create text index</title>\n");
  printf("</head><body  bgcolor=\"f2F8d4\">");
  printf("<h1>The attribute you set is shown below:</h1>\n");
  printf("<pre>\n");

  /*================================================================= 
     There are five fields can't be empty: 
     sdPath-directory-lst, extension-filename-list, template-file-path, 
     homepage directory path, and temp file directory path.
     The other fields are optional.
    =================================================================*/

  for (i=0; i<total_item; i++)
    {
    if ((i)&&(i != total_item-1))  
      printf("<font face=\"Courier New, Courier, mono\" size=2>"
             " %-11.9s == %s </font> \n", item[i].name, item[i].value );
  	  
    /*item[0] assign the password of web administrator */
    if (strcmp(item[i].name, "passwd")==0)
      strcpy(passwd, item[i].value);

    /* the search directory path list*/
    else if (strcmp(item[i].name, "sdPath")==0)
      strcpy(sdPath, item[i].value);
 
    /* whether the program recursively process subdirectory */
    else if (strcmp(item[i].name, "recurse")==0)
      recurse=atoi(item[i].value);

    /* forbidden directory path list*/
    else if (strcmp(item[i].name, "fdPath")==0)
      strcpy(fdPath, item[i].value);

    /* the template html file path */
    else if (strcmp(item[i].name, "template")==0)
      strcpy(template, item[i].value);

    /* the wanted extension filename */
    else if (strcmp(item[i].name, "ext")==0)
      strcpy(ext, item[i].value);
  
    /* how many items shown per page */    
    else if (strcmp(item[i].name, "hitPerP")==0)
      hitPerP=atoi(item[i].value);

    /* score formula, 
    default 10 means score=5*(10*hit of title+ hit of content) */
    else if (strcmp(item[i].name, "weight")==0)
      weight=atoi(item[i].value);

    /* whether web administrator log client user's operation */
    else if (strcmp(item[i].name, "log")==0)
      log=atoi(item[i].value);
    
    /* decide language version of message shown to client user */
    else if (strcmp(item[i].name, "version")==0)
      strcpy(version, item[i].value);
      
    else if (strcmp(item[i].name, "homeDir")==0)
      strcpy(homeDir, item[i].value);

    else if (strcmp(item[i].name, "tempDir")==0)
      strcpy(tempDir, item[i].value);
      
    /* highlight color */      
    else if (strcmp(item[i].name, "color")==0)
      {
      sprintf(preTag, "<font color=\"%s\">", item[i].value); 
      strcpy(endTag, "</font>");
      }

    /* highlight font style(Bold or Italic) */
    else if (strcmp(item[i].name, "bold")==0)
      { 
      strcat(preTag, "<b>");
      strcat(endTag, "</b>");
      }
    else if (strcmp(item[i].name, "italic")==0)
      {
      strcat(preTag, "<i>");
      strcat(endTag, "</i>");  
      }
    }
  printf("</pre>\n");
  
  /*=== check whether the template file contain the necessary tag ===*/
  if (check(template, SEARCHTAG))
    goto EXIT;    

  /*=== find data and insert into database ===*/
  total=proWebAdm(sdPath, ext, fdPath, recurse, template, log, hitPerP, 
                  weight, passwd, preTag, endTag, version, homeDir, tempDir);
  
  printf("<br>Total number are %d items.<br> \n", total);
                    
  printf("<script language=\"javascript\"> \n");
  printf("  alert(\"The data construction is complete, the number of data is %d item\") \n", total);
  printf("</script>\n");
  
  printf("<form action=\"view.cgi\" method=\"post\"> \n");
  printf("  <input type=\"submit\" name=\"viewRecord\" value=\" View Inserted data \"> \n");
  printf("</form> \n");
          
EXIT:
  printf("</body></html>");    
  return;  
}

/**********************************************************************
*
*  Process All jobs for Web Administrator, describe below:
*
*  FUNCTION =
*    .  Record attributes of property
*    .  Insert setting of path to table Path.
*    .  Insert setting of parameter to table Params.
*    .  Search all the search directoried 
*    .  Find tagarget file with assigned filename extensions
*    .  Insert found data into table WebPage
*    .  Divided content of template file with SEARCHTAG and 
*       insert the two part into table Output
*    .  Return count of inserted data 
*
*
*  RETURNED VALUE=
*       total count of inserted data
*
***********************************************************************/

static int proWebAdm(
  char *sdPath,      /* IN search directoried path */
  char *extNames,    /* IN filename extensions */
  char *fdPath,      /* IN forbidden directories path */
  int  recurse,      /* IN whether recursively process sub-directory */
  char *tFile,       /* IN template file location */
  int  log,          /* IN whether log operation of client */
  int  hitP,         /* IN hit count per page */
  int  weight,       /* IN weight of title such that we can get a score */
  char *passwd,      /* IN password to connect to database */
  char *preTag,      /* IN preTag to add in front of searched pattern word */
  char *endTag,      /* IN endTag to add in back of search pattern word */
  char *version,     /* IN language version to support multi-language message */ 
  char *homeDir,     /* IN homepage directory */
  char *tempDir)     /* IN temp directory to put temporary file */
{
  int  cExt=0;                /* count of assigned filename extensions */
  int  cForbid=0 ;            /* count of forbidden directories */
  int  cSearch=0;             /* count of search directories */
  int  ifindex;               /* whether there is a text index existed */
  int  len;				
  char *extName[COUNT_EXT];   /* array to record filename extensions */
  char *forbidDir[COUNT_DIR]; /* array to recrod forbidden directories */
  char *searchDir[COUNT_DIR]; /* array to recrod search directories */
  char *token;                /* point to a segment of string divided by a symbol */ 
  
  if (sdPath[0] != 0)
    {
    token=strtok(sdPath,";, ");
    for (cSearch=0;token !=NULL;cSearch++)
      {
      len=strlen(token);
      searchDir[cSearch]=token;

      if ((! isDbcsHi(token[len-2]) &&
          (token[len-1] == SLASH)))
        (searchDir[cSearch])[len-1]=0;

      token=strtok(NULL,";, ");
      }
    }

  token=strtok(extNames,";, ");
  for (cExt=0; token != NULL; cExt++)
    {
    extName[cExt]=token;
    token=strtok(NULL,";, ");
    }
  
  if (fdPath[0]!=0)
    {
    token=strtok(fdPath,";, ");
    for (cForbid=0; token != NULL; cForbid++)
      {
      len=strlen(token);
      forbidDir[cForbid]=token;

      if ((! isDbcsHi(token[len-2]) &&
          (token[len-1] == SLASH)))
        (forbidDir[cForbid])[len-1]=0;

      token=strtok(NULL, ";, ");
      }
    }

  if (SQLAllocEnv(&henv))
    printf("allocate envrionment handle fail !! \n");
  if (SQLAllocConnect(henv,&hdbc))
    printf("allocate connection handle fail !! \n");

  /*=== Connect to Database DBNAME ===*/
  SQLConnect(hdbc, (UCHAR *)DBNAME, SQL_NTS, (UCHAR *)"SYSADM", 
             SQL_NTS, (UCHAR *)passwd, SQL_NTS);  
  checkrc(RTN_OK, henv, hdbc, NULL);  
  SQLSetConnectOption(hdbc, SQL_AUTOCOMMIT, SQL_AUTOCOMMIT_OFF);
  checkrc(RTN_OK, henv, hdbc, NULL);  
  SQLAllocStmt(hdbc,&hstmt);
  checkrc(RTN_OK, henv, hdbc, hstmt);  

  /* check whether there has been a text index, if yes, drop the text index */
  SQLExecDirect(hstmt, (UCHAR *)"select count(*) from SYSTEXTINDEX where TABLE_NAME='WebPage'", SQL_NTS);
  checkrc(RTN_OK, henv, hdbc, hstmt);  
  SQLBindCol(hstmt, 1, SQL_INTEGER,  &ifindex, 0, NULL);
  checkrc(RTN_OK, henv, hdbc, hstmt);  
  SQLFetch(hstmt);
  checkrc(RTN_OK, henv, hdbc, hstmt);  

  SQLFreeStmt(hstmt, SQL_CLOSE);
  checkrc(RTN_OK, henv, hdbc, hstmt);  

  if (ifindex==1)  
    {
    SQLExecDirect(hstmt, (UCHAR *)"drop text index content_idx from WebPage", SQL_NTS);
    checkrc(RTN_OK, henv, hdbc, hstmt);
    }
  
 /*=== delete data of table WebPage, Path, Output, and Params ===*/
  if (SQLExecDirect(hstmt, (UCHAR *)"delete from WebPage", SQL_NTS) ||
      SQLExecDirect(hstmt, (UCHAR *)"delete from Path", SQL_NTS) ||
      SQLExecDirect(hstmt, (UCHAR *)"delete from Output", SQL_NTS) ||
      SQLExecDirect(hstmt, (UCHAR *)"delete from Params where name!='passwd'", SQL_NTS))
    checkrc(RTN_OK, henv, hdbc, hstmt);

  /*=== Produce a commit operation ===*/
  SQLTransact(henv, hdbc, SQL_COMMIT);
  checkrc(RTN_OK, henv, hdbc, hstmt);

  insertPath(searchDir, cSearch, extName, cExt, forbidDir, cForbid, tFile, homeDir, tempDir); 
  insertWebPage(searchDir, cSearch, extName, cExt, forbidDir, cForbid, recurse);
  insertOutput(tFile); 
  insertParams(preTag, endTag, hitP, weight, log, recurse, version);

EXIT:
  SQLDisconnect(hdbc);
  SQLFreeConnect(hdbc);
  SQLFreeEnv(henv);
  return num;
}

/****************************************************************************
 Find all the filenames containing assigned file extensions 
 in the assigned search directory and its subdirectory                                                                                                    
 ****************************************************************************/
static void findAndInsert(
  char* dirName,   /* IN directory to process */
  char* ext[],     /* IN array of target filename extension */
  int   cExt,      /* IN count of target filename extension */
  char* forbid[],  /* IN forbidden directories */
  int   cForbid,   /* IN count of forbidden directories */
  int   recurse)   /* IN whether recursively process sub-directory */
{  
#ifdef WIN32  
  HANDLE  dirp=0;  
  WIN32_FIND_DATA dirent;
  LPWIN32_FIND_DATA direntp=&dirent;
  struct  stat statbuf;   
#else
  DIR    *dirp = NULL;
  struct dirent *direntp;
  struct stat statbuf;  
#endif
  
  int   i, j; /* i,j is just used to counting */
  int   rc=0;
  char  *fname=NULL;
  char  *pDest=NULL;
  char  path[LEN_FNAME];
  char  fullname[LEN_FNAME];

  for (j=0; j<cForbid; j++)
    {
#ifndef WIN32      
    if (strcasecmp(dirName, forbid[j]) == 0 )
#else
    if (stricmp(dirName, forbid[j]) == 0 )
#endif    
      return;
      /*=== can't enter the forbidden directory ===*/
    }

   sprintf(path,"%s%c", dirName, SLASH);

#ifdef WIN32
  strcat(dirName, "\\*");
#endif   

  WS_OPENDIR(dirName, direntp, dirp, rc);
  if (rc)
    { 
    printf("Open Directory %s error<br>\n", dirName); 
    goto EXIT;
    }

  WS_READDIR(dirp, direntp, rc);
  while(rc==0)
    {
    WS_GETFILENAME(direntp, fname);
    sprintf(fullname, "%s%s",path, fname);      
    strcpy(fobj, fullname);
 
    /* decide whether the fullname is a directory */
    if (stat(fullname, &statbuf)) 
      {
      printf("\n<br>File [%s] get stat information error, no such file or directory<br>\n", fullname);      
      goto NEXT;
      }
    else                                   
      {
      if (S_IFDIR & statbuf.st_mode)
        {
        /*=== file is a directory ===*/
        if ( strcmp(fname, ".")  && strcmp(fname, "..") )
          {
          if (recurse)
            findAndInsert(fullname, ext, cExt, forbid, cForbid, recurse);            
            /*=== recursively process subdirectory ===*/
          }
        }
      else /*=== file is not a directory ===*/
        {
        if (((pDest=strrchr(fname,'.')) != NULL) && (*(pDest+1) != 0))
          {
          for (i=0; i<cExt; i++)
            {
#ifndef WIN32
            if (strcasecmp(pDest+1, ext[i]) ==0)             
#else 
            if (stricmp(pDest+1, ext[i]) ==0)             
#endif
              {
              /*=== This file is a target file ===*/
              processFile(ext[i], fullname, statbuf);
              break;
              }            
            }       
          }
        }  
      }
NEXT:    
    WS_READDIR(dirp, direntp, rc);
    }
EXIT:  
  if (dirp)    
    WS_CLOSEDIR(dirp);
}

/***************************************************************************
 Process those files which have the target filename extension 
 (ex: .htm or .html file) and insert associate data into table WebPage
****************************************************************************/
static void processFile(char *extName, char *fname, struct stat statbuf)
{
  SDWORD  rc=0;
  char    *tmpBuf=NULL; /* temp buffer to put character data */
  char    *fhtml=NULL;  /* used to save content of HTML file */
  int     htmlSize;     /* character count of HTML file */
  int     textSize;     /* character count of pure text of converted HTML file */
  PTR     pAddr;
  
  title[0]=0;
  htmlSize=statbuf.st_size; 
  if ((fhtml=malloc(htmlSize+1)) == NULL ) 
    {
    printf("Memory Allocate error");
    goto EXIT;
    }
  /*=== copy content of fname to fhtml, file size is htmlSize ===*/
  copyFile(fname, fhtml, htmlSize);

  /*=========================================================================
   If filename extension is "htm" or "html"  
   treate the file as a html file, else treate the file as a pure text file 
   ==========================================================================*/
#ifndef WIN32
  if (strncasecmp(extName, "htm", 3)==0) 
#else
  if (strnicmp(extName, "htm", 3)==0)   
#endif
    {
    if ((tmpBuf=malloc(htmlSize+1)) == NULL )
      {
      printf("Allocate content error");
      goto EXIT;
      }        
    findTitle(fhtml, htmlSize, title);
    html2text(fhtml, htmlSize, tmpBuf, htmlSize, &textSize);
    }

  if (title[0] == 0) 
    strcpy(title, "Untitled document");
  num++;
  
  rc=SQLExecute(hstmt);
  if ( rc == SQL_NEED_DATA)
    {
    while (( rc=SQLParamData(hstmt, &pAddr)) == SQL_NEED_DATA)
      {
      if (tmpBuf)
        rc=SQLPutData(hstmt, tmpBuf, strlen(tmpBuf));
      else 
        rc=SQLPutData(hstmt, fhtml, strlen(fhtml));
      }
    checkrc(RTN_OK, henv, hdbc, hstmt); 
    }

EXIT:   
  if (tmpBuf) 
	  free(tmpBuf);
  if (fhtml)  
	  free(fhtml);
}


/****************************************************************************
*
*  Insert data to table Path(type, path) 
*    . type:  represent it is search directory, forbidden direcory, 
*             template file, or homepage directory
*    . path:  path of search directory, forbidden directory, template file, 
*             or homepage directory
*    
*****************************************************************************/
static void insertPath(
  char *searchDir[],    /* IN search directories array */
  int  cSearch,         /* IN count of search directories */
  char *extName[],      /* IN target filename extensions array */
  int  cExt,            /* IN count of target filename extensions */
  char *forbidDir[],    /* IN forbidden directories array */
  int  cForbid,         /* IN count of forbidden directories */
  char *tFile,          /* IN template fileaname */
  char *homeDir,        /* IN homepage directory */
  char *tempDir)        /* IN temp directory to put temporary file */
{
  int    i;
  char   type[LEN_PARAM];   
  char   path[LEN_FNAME];
  char   str1[1000];
  SDWORD cbtype=SQL_NTS;
  SDWORD cbpath=SQL_NTS;

  strcpy(str1, "insert into Path(type, path) values (?,?)");
  SQLPrepare(hstmt, (UCHAR *)str1, SQL_NTS);
  checkrc(RTN_OK, henv, hdbc, hstmt);

  SQLBindParameter(hstmt, 1, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_VARCHAR, 
                   LEN_PARAM, 0,  type, 0, &cbtype);
  checkrc(RTN_OK, henv, hdbc, hstmt);
  SQLBindParameter(hstmt, 2, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_VARCHAR,
                   LEN_FNAME, 0,  path, 0, &cbpath);
  checkrc(RTN_OK, henv, hdbc, hstmt);

  for (i=0; i<cSearch; i++)
  {  
    strcpy(type,"search"); 
    strcpy(path,searchDir[i]); 
    SQLExecute(hstmt);
    checkrc(RTN_OK, henv, hdbc, hstmt);
  }

  for (i=0; i<cExt; i++)
  {
    strcpy(type,"ext"); 
    strcpy(path,extName[i]); 
    SQLExecute(hstmt);
    checkrc(RTN_OK, henv, hdbc, hstmt);
  }

  for (i=0; i<cForbid; i++)
  {
    strcpy(type, "forbid");
    strcpy(path, forbidDir[i]);
    SQLExecute(hstmt);
    checkrc(RTN_OK, henv, hdbc, hstmt);
  }

  strcpy(type, "template");
  strcpy(path, tFile);
  SQLExecute(hstmt);
  checkrc(RTN_OK, henv, hdbc, hstmt);
  
  strcpy(type, "homeDir");
  strcpy(path, homeDir);
  SQLExecute(hstmt);
  checkrc(RTN_OK, henv, hdbc, hstmt);
  
  strcpy(type, "tempDir");
  strcpy(path, tempDir);
  SQLExecute(hstmt);
  checkrc(RTN_OK, henv, hdbc, hstmt);

  /*=== Produce a commit operation ===*/
  SQLTransact(henv, hdbc, SQL_COMMIT);
  checkrc(RTN_OK, henv, hdbc, hstmt); 
  
  SQLFreeStmt(hstmt, SQL_RESET_PARAMS);
  checkrc(RTN_OK, henv, hdbc, hstmt);  
EXIT:
  return;
}

/****************************************************************************
 Insert data to table WebPage(
    num,          // serial number of inserted data
    title,        // title of html file
    content,      // file content
    fobj)         // file object 
 ****************************************************************************/
static void insertWebPage(
  char *searchDir[],    /* IN search directories array */
  int  cSearch,         /* IN count of search directories */
  char *extName[],      /* IN target filename extensions array */
  int  cExt,            /* IN count of target filename extensions */
  char *forbidDir[],    /* IN forbidden directories array */
  int  cForbid,         /* IN count of forbidden directories */
  int  recurse)         /* IN whether recursive process sub-directory */
{
  char str1[1000];
  int  i;

  printf("<BR><b>====Insert into WebPage values ====</b><br><br>\n");
  strcpy(str1,
		"insert into WebPage(num, title, content, fobj) values (?,?,?,?)");
  SQLPrepare(hstmt, (UCHAR *)str1, SQL_NTS);
  checkrc(RTN_OK, henv, hdbc, hstmt);
   
  /* =============================================================
      parameter $1, $2, $3, $4
          $1 is serial num, $2 is title(temporarily filename saved)
          $3 is pure text content of .htm or .html file
          $4 is fileObject
     ============================================================= */

  SQLBindParameter(hstmt, 1, SQL_PARAM_INPUT, SQL_C_LONG, SQL_INTEGER, 
                           0, 0,  &num, 0, NULL);
  checkrc(RTN_OK, henv, hdbc, hstmt);
  SQLBindParameter(hstmt, 2, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_VARCHAR,
                   LEN_TITLE, 0, title, 0, &cbtitle);
  checkrc(RTN_OK, henv, hdbc, hstmt);
  SQLBindParameter(hstmt, 3, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_LONGVARCHAR,
                           0, 0,  NULL, 0, &cbcontent);
  checkrc(RTN_OK, henv, hdbc, hstmt);
  SQLBindParameter(hstmt, 4, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_FILE,
                   LEN_FNAME, 0,  fobj, 0, &cbfobj);
  checkrc(RTN_OK, henv, hdbc, hstmt);
                   
  for (i=0; i<cSearch; i++)
    findAndInsert(searchDir[i], extName, cExt, forbidDir, cForbid, recurse);
  
  /*=== Create Text index on content of WebPage ===*/
  strcpy(str1,\
         "create text index content_idx on WebPage(content) cluster width 2048");
  SQLExecDirect(hstmt,(UCHAR *)str1, SQL_NTS);
  checkrc(RTN_OK, henv, hdbc, hstmt);

  /*=== Produce a commit operation ===*/
  SQLTransact(henv, hdbc, SQL_COMMIT);
  checkrc(RTN_OK, henv, hdbc, hstmt); 
  SQLFreeStmt(hstmt, SQL_RESET_PARAMS);
  checkrc(RTN_OK, henv, hdbc, hstmt);  
EXIT:
  return;
}

/****************************************************************************
 Insert table Output(
    header,     // html file content in front of SEARCHTAG in template file
    footer)     // html file content in back of SEARCHTAG in template file
 ****************************************************************************/
static void insertOutput(
  char *tFile)      /* template file location */
{
  char    *fcontent=NULL;   /* total file content of html file */
  char    *header=NULL;     /* file content in front of SEARCHTAG */
  char    *footer=NULL;     /* file content in back of SEARCHTAG */
  char    *Param[2];      
  char    *ploc=NULL;        /* pointer to location which SEARCHTAG resided */
  char    str1[1000];
  SDWORD  rc=0;
  SDWORD  cbheader;
  SDWORD  cbfooter;
  SDWORD  len[2];           
  PTR     pAddr2;           /* used to process blob data */
  struct  stat statbuf;
  int     fileLen;          /* file length of html file */
  int     aux;              /* aux recognize byte count of header */
  int     i;               
 
  cbheader=cbfooter=SQL_DATA_AT_EXEC;
  if (stat(tFile, &statbuf))
    printf("\n<br><font color=\"red\">template file %s doesn't exists</font><br>\n", tFile);
  else
    fileLen=statbuf.st_size;
 
  if ((fcontent=malloc(fileLen+1)) == NULL )
    printf("memory allocation error \n");
  else
    {
    copyFile(tFile, fcontent, fileLen);
    
    aux=strCaseStrOffset(fcontent, SEARCHTAG);  
    /* find location offset of SEARCHTAG from beginning of fcontent */
      
    header=fcontent;
    footer=fcontent+aux+strlen(SEARCHTAG); /* skip the SEARCHTAG <!--$DBMSEARCH$--> */
    
    strcpy(str1, "insert into Output(header, footer) values (?, ?)");
    SQLPrepare(hstmt, (UCHAR *)str1, SQL_NTS);
    checkrc(RTN_OK, henv, hdbc, hstmt); 
    
    if (SQLBindParameter(hstmt, 1, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_LONGVARCHAR,
                     0, 0, NULL, 0, &cbheader) ||
        SQLBindParameter(hstmt, 2, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_LONGVARCHAR,
                     0, 0, NULL, 0, &cbfooter))
      checkrc(RTN_OK, henv, hdbc, hstmt); 

    rc = SQLExecute(hstmt);
    Param[0]=header; Param[1]=footer;
    len[0]=aux; len[1]= strlen(footer);
    if ( rc == SQL_NEED_DATA)
      {
      i=0;
      while (( rc=SQLParamData(hstmt, &pAddr2)) == SQL_NEED_DATA)
        {
        rc=SQLPutData(hstmt, Param[i], len[i]);
        checkrc(RTN_OK, henv, hdbc, hstmt); 
        i++;
        }
      }
    }
EXIT:
  SQLFreeStmt(hstmt, SQL_RESET_PARAMS);
  checkrc(RTN_OK, henv, hdbc, hstmt);  
  
  if (fcontent) 
    free(fcontent);
}

/****************************************************************************
 Insert one record into table Params(name, chValue, intValue) 
 ****************************************************************************/
static int insertOneParam(
  char *name,
  char *chValue,
  int  intValue)
{
  SDWORD  cbname=SQL_NTS;
  SDWORD  cbchValue;
  SDWORD  cbintValue;
  SQLPrepare(hstmt, (UCHAR *)"insert into Params(name, chValue, intValue) values (?,?,?)", SQL_NTS);
  checkrc(RTN_OK, henv, hdbc, hstmt);

  if (SQLBindParameter(hstmt, 1, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_VARCHAR,
                       LEN_NAME   , 0,      name, 0, &cbname) ||
      SQLBindParameter(hstmt, 2, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_VARCHAR,
                       LEN_CHVALUE, 0,   chValue, 0, &cbchValue) ||
      SQLBindParameter(hstmt, 3, SQL_PARAM_INPUT, SQL_C_LONG, SQL_INTEGER,
                        0,          0, &intValue, 0, &cbintValue))
      checkrc(RTN_OK, henv, hdbc, hstmt); 
  
  cbchValue = (chValue) ? SQL_NTS : SQL_NULL_DATA;
  cbintValue = (intValue == -1) ? SQL_NULL_DATA : 0;
  if (SQLExecute(hstmt))
    checkrc(RTN_OK, henv, hdbc, hstmt); 
  SQLFreeStmt(hstmt, SQL_RESET_PARAMS);
  checkrc(RTN_OK, henv, hdbc, hstmt);  
  return(0);
EXIT:
  return(-1);
}

/****************************************************************************
 Insert table Params(name, chValue, intValue) 
 ****************************************************************************/
static void insertParams(
  char *preTag,     /* IN preTag to add in front of searched pattern word */
  char *endTag,     /* IN endTag to add in back of searched pattern word */
  int  hitPerP,     /* IN hit count per page */
  int  weight,      /* IN weight of title */
  int  log,         /* IN whether log operation of client */  
  int  recurse,     /* IN whether recursively process sub-directory */
  char *version)    /* IN string to represent language version */
{    
  if (insertOneParam("preTag", preTag, -1) ||
      insertOneParam("endTag", endTag, -1) ||
      insertOneParam("log",    0,      log) ||
      insertOneParam("hitPerP",0,      hitPerP) ||
      insertOneParam("weight", 0,      weight) ||
      insertOneParam("recurse",0,      recurse) ||
      insertOneParam("version",version,-1))
    return;
        
  SQLTransact(henv, hdbc, SQL_COMMIT);
  checkrc(RTN_OK, henv, hdbc, hstmt); 
EXIT: ;
}

