/****************************************************************************
*    Copyright (c) 1999 CASEMaker Inc.                                      *
*    http://www.dbmaker.com  http://www.dbmaker.com.tw                      *
*    You may distribute under the terms of the GNU General Public License.  *
*                                                                           *
*    dmwebut.c                                                              *
*    Function to retrieve CGI string names and values                       *
****************************************************************************/
#include "dmwebut.h"

/*********************************************
  static function prototype of 
 *********************************************/
static void transferURL(char *url);
static void plus2space(char *str);
static void getWord(char *string, char stop, char *word);

/*********************************************
 * get arguments of CGI 
 *********************************************/ 
void DWGetItem()
{
  char  *CGIPara=NULL;
  char  *ptr=NULL;
  int   i,len;

  ptr = getenv("CONTENT_LENGTH");

  if (ptr)
    {
    len = atoi(ptr);
    CGIPara = (char*)malloc(len+1);
    i = read(0, CGIPara, len);     /* get arguments for standard in */
    }
  else
    CGIPara = getenv("QUERY_STRING");

  if (CGIPara == NULL)
    {
    total_item = 0;
    return;
    }

  for(i=0; CGIPara[0] != 0; i++)
    {
    getWord(CGIPara, '=', item[i].name);
    getWord(CGIPara, '&', item[i].value);
    plus2space(item[i].value);               /* transfer plus to space           */
    transferURL(item[i].value);              /* handle Chinese words and special characters */
    }
  
  total_item = i;
  if (ptr)
    free(CGIPara);
}


#define HexVal(c) (((c) >= 'A' ) ? ((c) & 0xdf) - 'A' + 10 : (c) - '0')
#define Hex2Char(inputS) (HexVal((inputS)[0])*16+HexVal((inputS)[1])) 


/***********************************************
 * handle Chinese Words and special characters  
 ***********************************************/ 
static void transferURL(char *url) 
{
  int i,j;

  for (i=0,j=0; url[j]; ++i,++j)  
    {
    if (url[j] == '%' && url[j+1] && url[j+2]) /* special characters */
      {
      url[i] = Hex2Char(url+j+1);
      j += 2;  
      }  
    else url[i] = url[j];
    }
  url[i] = 0;
}

/*********************************************
 * transfer '+' to space                      
 *********************************************/ 
static void plus2space(char *str) 
{
  int i;

  for (i=0; str[i]; i++) 
    if (str[i] == '+') 
      str[i] = ' ';
}

/*********************************************
 * get a word ending by the stop character                              
 *********************************************/ 
static void getWord(
  char *string,     /* IN/OUT : input string   */ 
  char stop,        /* IN     : stop character */ 
  char *word)       /* OUT    : output word    */
{
  int  i,j;

  for (i=0; string[i] && (string[i] != stop); i++)
    word[i] = string[i];

  word[i] = '\0';
  if (string[i])  
    i++;
  j = 0;
  while (string[j++] = string[i++]);
}

