/****************************************************************************
*    Copyright (c) 1999 CASEMaker Inc.                                      *
*    http://www.dbmaker.com  http://www.dbmaker.com.tw                      *
*    You may distribute under the terms of the GNU General Public License.  *
*                                                                           *                                                                        * 
*    login.c:                                                               *
*    CGI program which web administrator use to login and                   *
*    alter SYSADM password at the first time.                               *
*****************************************************************************/
#include "webut.h"
#include "dmwebut.h"

DWitem item[MAX_ITEMS];
int    total_item;

/****************************************************************************
 check whether the webadministraton first logins the database. If he/she 
 logins at the first time, the function will return 1, else return 0;
 ****************************************************************************/
int checkFirst(int fgInsert)
{
  char    str1[1000];       /* just used to put temp string */
  SDWORD  rc;         
  HENV    henv;
  HDBC    hdbc;
  HSTMT   hstmt;
  int     fgFirst = TRUE;   /* used to check the user is login at the first time */
  int     intValue;
    
  if (SQLAllocEnv(&henv))
    printf("allocate envrionment handle fail !! \n");
  if (SQLAllocConnect(henv,&hdbc))
    printf("allocate connection handle fail !! \n");

  /*=== User Guest with priviledge DBA Connect to Database DBNAME ===*/
  SQLConnect(hdbc, (UCHAR *)DBNAME, SQL_NTS, (UCHAR *)"guest", 
             SQL_NTS, (UCHAR *)"", SQL_NTS);
  checkrc(RTN_OK, henv, hdbc, NULL);
  SQLSetConnectOption(hdbc, SQL_AUTOCOMMIT, SQL_AUTOCOMMIT_OFF);
  checkrc(RTN_OK, henv, hdbc, NULL);
  SQLAllocStmt(hdbc,&hstmt);
  checkrc(RTN_OK, henv, hdbc, hstmt);  

  sprintf(str1, "select intValue from SYSADM.Params where name='passwd'");
  SQLExecDirect(hstmt, (UCHAR *)str1, SQL_NTS);
  checkrc(RTN_OK, henv, hdbc, hstmt);

  SQLBindCol(hstmt, 1, SQL_C_LONG, &intValue, 0, NULL);
  checkrc(RTN_OK, henv, hdbc, hstmt);
  
  rc=SQLFetch(hstmt);
  if (rc==SQL_SUCCESS || rc==SQL_SUCCESS_WITH_INFO)
    {
    fgFirst = FALSE;
    goto EXIT;
    }
    
  SQLFreeStmt(hstmt, SQL_UNBIND);
  checkrc(RTN_OK, henv, hdbc, hstmt);
  SQLFreeStmt(hstmt, SQL_CLOSE);
  checkrc(RTN_OK, henv, hdbc, hstmt);
  
  /*========================================================================= 
    if fgInsert=1, it means the web administrator login at the first time, 
    then will insert a value into Params table and in the future 
    our program can check whether the value is in table Params 
    to decide whether the user login at the first time
    =========================================================================*/
  if (fgInsert)    
    {
    sprintf(str1, "insert into SYSADM.Params values('passwd', NULL, 1)");
    SQLExecDirect(hstmt, (UCHAR *)str1, SQL_NTS);
    checkrc(RTN_OK, henv, hdbc, hstmt);
      
    /*=== Produce a commit operation ===*/
    SQLTransact(henv, hdbc, SQL_COMMIT);
    checkrc(RTN_OK, henv, hdbc, hstmt);  
    }

  SQLFreeStmt(hstmt, SQL_DROP);
  checkrc(RTN_OK, henv, hdbc, hstmt);
EXIT:
  SQLDisconnect(hdbc);
  SQLFreeConnect(hdbc);
  SQLFreeEnv(henv);
  return (fgFirst);
}

/* Just show javascript html code */
void showScriptCode()
{
  printf("<script language=\"JavaScript\"> \n");

  printf("function check_input() { \n");
  printf("var status=true; \n");
  printf("  if (document.property.sdPath.value.length ==0) \n");
  printf("    { status=false; \n");
  printf("      alert(\"Please input search directory.\");");
  printf("      return status;}\n");
  printf("  if (document.property.ext.value.length ==0) \n");
  printf("    { status=false; \n");
  printf("      alert(\"Please input filename extension.\");");
  printf("      return status;}\n");
  printf("  if (document.property.template.value.length ==0) \n");
  printf("    { status=false; \n");
  printf("      alert(\"Please input template file location.\");");
  printf("      return status;}\n");
  printf("  if (document.property.homeDir.value.length ==0) \n");
  printf("    { status=false; \n");
  printf("      alert(\"Please input homepage directory.\");");
  printf("      return status;}\n");
  printf("  if (document.property.tempDir.value.length ==0) \n");
  printf("    { status=false; \n");
  printf("      alert(\"Please input temp directory, the directory must have been existed.\");");
  printf("      return status;}\n");
  printf("  return status; \n");
  printf("}; \n");

  printf("function enableText() \n");
  printf("  {document.property.fdPath.disabled=0;} \n");
  
  printf("function disableText() \n");
  printf("  {document.property.fdPath.disabled=1;} \n");

  printf("</script>   \n");  
}

/****************************************************************************
 Main function 
 ****************************************************************************/
void main()
{
  HENV   henv;
  HDBC   hdbc;
  HSTMT  hstmt;
  int    hitPerP;       /* hit count per page */
  int    weight;        /* weight of title */
  int    i;             
  int    intValue;      
  int    fgConfirm=0;   /* the web adminstrator clicked ok button to confirm alter password */
  SDWORD rc=0;
  SDWORD cbname;
  SDWORD cbpath;
  SDWORD cbtype;
  SDWORD cbchValue;
  SDWORD cbintValue;
  char   str1[1000];
  char   *token;              /* a temp buffer to retrieve string segment */
  char   sdPath[LEN_PATHS];   /* array of search directories */
  char   fdPath[LEN_PATHS];   /* array of forbidden directories */
  char   ext[LEN_EXT];        /* array of filename extensions */
  char   template[LEN_FNAME]; /* template file */
  char   homeDir[LEN_FNAME];  /* homepage directory */
  char   tempDir[LEN_FNAME];  /* temp directory to put temporary file */
  char   logNo[LEN_HTML];             /***********************************/
  char   logYes[LEN_HTML];            /*                                 */
  char   recurseNo[LEN_HTML];         /* All the variable are used to    */
  char   recurseYes[LEN_HTML];        /* modify HTML content such that   */
  char   versionChinese[LEN_HTML];    /* we can assign checkbox to be    */  
  char   versionEnglish[LEN_HTML];    /* checked or radio button to be   */
  char   bold[LEN_HTML];              /* selected                        */
  char   italic[LEN_HTML];            /*                                 */
  char   version[LEN_HTML];           /***********************************/  
  char   type[LEN_NAME];      /*  type are used in table Path         */  
  char   path[LEN_FNAME];     /*  path are alos used in table Path    */
  char   name[LEN_NAME];      /*  attribute name of property          */
  char   chValue[LEN_CHVALUE];/*  value of property atribute          */  
  char   passwd[LEN_PWD];     /*  password            */
  char   newPasswd[LEN_PWD];  /*  new password        */
  char   confirm[LEN_PWD];    /*  confirmed password  */
  char   color[6];            /* highlight color      */
  
  /* inititalize variable value */  
  sdPath[0]=fdPath[0]=ext[0]=template[0]=passwd[0]=confirm[0]=newPasswd[0]=0;
  strcpy(logNo,"checked"); 
  logYes[0]=0;
  strcpy(recurseNo,"checked"); 
  recurseYes[0]=0;
  strcpy(versionEnglish, "checked"); 
  versionChinese[0]=0;
  homeDir[0]=tempDir[0]=0;
  strcpy(bold, "checked");
  strcpy(color, "FF0000");
  italic[0]=0;    
  hitPerP=weight=10;

  printf("Content-type: text/html\n\n");
  printf("<html><head>");
  printf("<meta http-equiv=Content-Type content=\"text/html; charset=big5\">\n");
  printf("<title>Property</title>\n");  
  printf("</head> \n");

  DWGetItem();
    
  for (i=0; i<total_item; i++)
    {
    if (strcmp(item[i].name, "passwd")==0)
      strcpy(passwd, item[i].value);
    else if (strcmp(item[i].name, "newPasswd")==0)
      strcpy(newPasswd, item[i].value);
    else if (strcmp(item[i].name, "confirm")==0)
      strcpy(confirm, item[i].value);
    else if (strcmp(item[i].name, "ok")==0)
      fgConfirm=1;
    }

  /* checkFirst is used to determine the user is first login, 
     if he logins at the first time, 
     the function will return 1, else return 0 */
  if (checkFirst(fgConfirm))
    {
    if (fgConfirm==0)
      goto First;
    }  

  showScriptCode();

  /*=== initialize for environment handle ===*/ 
  if (SQLAllocEnv(&henv))
    printf("allocate envrionment handle fail !! \n");
    
  /*=== allocate connection handle ===*/
  if (SQLAllocConnect(henv,&hdbc))
    printf("allocate connection handle fail !! \n");
  
  rc = SQLConnect(hdbc, (UCHAR *)DBNAME, SQL_NTS, (UCHAR *)"SYSADM",
                  SQL_NTS, (UCHAR *)passwd, SQL_NTS);  
  if (rc)
    {
    printf("Invalid authorization specification <b>(invalid password when connecting)</b>"); 
    printf("<br>Please input the correct password ");
	  SQLFreeConnect(hdbc);
    SQLFreeEnv(henv);
    goto ReType;    
    }

  SQLSetConnectOption(hdbc, SQL_AUTOCOMMIT, SQL_AUTOCOMMIT_OFF);
  checkrc(RTN_OK, henv, hdbc, NULL);  
  SQLAllocStmt(hdbc,&hstmt);
  checkrc(RTN_OK, henv, hdbc, hstmt);     
 
  if (confirm[0])
    {
    sprintf(str1, "alter password NULL to '%s'", confirm);
    SQLExecDirect(hstmt, (UCHAR *)str1, SQL_NTS);
    checkrc(RTN_OK, henv, hdbc, hstmt);
    
    /*=== Produce a commit operation ===*/
    SQLTransact(henv, hdbc, SQL_COMMIT);
    checkrc(RTN_OK, henv, hdbc, hstmt);  
    strcpy(passwd, confirm);
    }
    
  /* select data from table Path and Params to get the original property */   
  SQLExecDirect(hstmt, (UCHAR *)"select type, path from Path", SQL_NTS);
  checkrc(RTN_OK, henv, hdbc, hstmt);

  SQLBindCol(hstmt, 1, SQL_C_CHAR, type, LEN_NAME, &cbtype);
  checkrc(RTN_OK, henv, hdbc, hstmt);
  SQLBindCol(hstmt, 2, SQL_C_CHAR, path, LEN_FNAME, &cbpath);
  checkrc(RTN_OK, henv, hdbc, hstmt);
  
  while (TRUE)
    {
    rc=SQLFetch(hstmt);
    if (rc==SQL_SUCCESS || rc==SQL_SUCCESS_WITH_INFO)
      {
      if ( strcmp(type, "search")==0)
        {
        strcat(sdPath, path); 
        strcat(sdPath, "; ");	
        }
      else if (strcmp(type, "ext")==0)
        {
        strcat(ext, path);
        strcat(ext, "; ");
        }
      else if (strcmp(type, "forbid")==0)
        {
        strcat(fdPath, path);
        strcat(fdPath, "; ");    
        }
      else if (strcmp(type, "template")==0)
        strcpy(template, path);
      else if (strcmp(type, "homeDir")==0)
        strcpy(homeDir, path);         	               	
      else if (strcmp(type, "tempDir")==0)
        strcpy(tempDir, path);         	               	
      }
    else 
      break;   
    }  
  
  if (ext[0]==0)
    strcpy(ext, "htm html");
  /* initialize the content of ext filed */    
    
  SQLFreeStmt(hstmt, SQL_UNBIND);
  checkrc(RTN_OK, henv, hdbc, hstmt);
  SQLFreeStmt(hstmt, SQL_CLOSE);
  checkrc(RTN_OK, henv, hdbc, hstmt);

  SQLExecDirect(hstmt, (UCHAR *)"select name, chValue, intValue from Params", SQL_NTS);
  checkrc(RTN_OK, henv, hdbc, hstmt);
  
  SQLBindCol(hstmt, 1, SQL_C_CHAR, name, LEN_NAME, &cbname);
  checkrc(RTN_OK, henv, hdbc, hstmt);
  SQLBindCol(hstmt, 2, SQL_C_CHAR, chValue, LEN_FNAME, &cbchValue);
  checkrc(RTN_OK, henv, hdbc, hstmt);
  SQLBindCol(hstmt, 3, SQL_C_LONG, &intValue, 0, &cbintValue);
  checkrc(RTN_OK, henv, hdbc, hstmt);
    
  while (TRUE)
    {
    rc=SQLFetch(hstmt);
    if (rc==SQL_SUCCESS || rc==SQL_SUCCESS_WITH_INFO)
      {
      if (strcmp(name, "log")==0)
        {
        if (intValue)
          { 
          strcpy(logYes,"checked"); 
          logNo[0]=0;
          }
        else 
          {
          strcpy(logNo, "checked"); 
          logYes[0]=0;
          }
        }
      else if (strcmp(name, "version")==0)
        {
        strcpy(version, chValue);
        if (version[0]=='c') /*  version=="chinese"  */
          {
          strcpy(versionChinese, "checked");
          versionEnglish[0]=0;
          }  
        else /*  version=="english"  */
          {
          strcpy(versionEnglish, "checked");
          versionChinese[0]=0;
          }
        }
      else if (strcmp(name, "recurse")==0)
        {
        if (intValue)
          { 
          strcpy(recurseYes,"checked"); 
          recurseNo[0]=0;
          }
        else 
          { 
          strcpy(recurseNo, "checked"); 
          recurseYes[0]=0;
          }
        }  
      else if (strcmp(name, "hitPerP")==0)
        hitPerP=intValue;
      else if (strcmp(name, "weight")==0)
        weight=intValue;
      else if (strcmp(name, "preTag")==0)
        {
        token = strtok(chValue,"<\"");
        /* the first one token is <font color="??????">, find out color value  */
        token=strtok(NULL, "<\"");
        strcpy(color, token);    
        token=strtok(NULL,"<");

        while(token != NULL)
          {
          /* find out whether <b> or <i> exists */
          if ((*token)=='b') 
            strcpy(bold, "checked");
          if ((*token)=='i') 
            strcpy(italic,"checked");
          token=strtok(NULL,"<");
          }
        }
      }
    else 
      break;      
    }    

  SQLFreeStmt(hstmt, SQL_DROP);
  checkrc(RTN_OK, henv, hdbc, hstmt);

  printf("<body bgcolor=\"f2F8d4\"> \n");
  printf("<div align=\"center\">");

  /*=== Produce the html table content of property setting ===*/
  printf("<img src=\"/images/attribute.gif\"> \n");

  printf("<form action=\"build.cgi\" method=\"POST\" onsubmit=\"return check_input()\" "
         "name=property>\n");
  printf("   <input type=hidden name=passwd value=\"%s\"> \n", passwd);  
  printf("<table border=\"1\" width=\"590\" cellpadding=\"3\" "
	     " cellspacing=\"0\"> \n");
  printf("  <tr>\n");
  printf("    <td width=\"35%%\" bgcolor=\"FAE5E6\" > \n");
  printf("      <b>Search directories</b></td>\n");
  printf("    <td width=\"65%%\" bgcolor=\"EFE7FC\">\n ");
  printf("      <input type=text name=sdPath value=\"%s\" size=40>\n",sdPath);
  printf("    </td>\n");
  printf("  </tr>\n");
  printf("  <tr>\n");
  printf("    <td width=\"35%%\" bgcolor=\"FAE5E6\"> \n");
  printf("      <b>Recursively process subdirectory?</b></td>\n");
  printf("    <td width=\"65%%\" bgcolor=\"EFE7FC\">\n");
  printf("      <input type=radio name=recurse value=1 onclick=\"enableText()\" %s>Yes\n", recurseYes);
  printf("      &nbsp;&nbsp;\n");
  printf("      <input type=radio name=recurse value=0 onClick=\"disableText()\" %s>No\n", recurseNo);
  printf("    </td>\n");
  printf("  </tr>\n");

  printf("  <tr>\n");
  printf("    <td width=\"35%%\" bgcolor=\"FAE5E6\"> \n");
  printf("      <b>Forbidden directories</b></td>\n");
  printf("    <td width=\"65%%\" bgcolor=\"EFE7FC\">\n");
  printf("      <input type=text name=fdPath value=\"%s\" size=40>\n", fdPath);
  printf("    </td>\n");
  printf("  </tr>\n");
  printf("  <tr>\n");
  printf("    <td width=\"35%%\" bgcolor=\"FAE5E6\">\n");
  printf("      <b>Filename extensions </b></td>\n");
  printf("    <td width=\"65%%\" bgcolor=\"EFE7FC\">\n"); 
  printf("      <input type=text name=ext size=40 value=\"%s\">\n", ext);
  printf("    </td>\n");
  printf("  </tr>\n");
  printf("  <tr>\n");
  printf("    <td width=\"35%%\" bgcolor=\"FAE5E6\">\n");
  printf("      <b>Template file</b></td>\n");
  printf("    <td width=\"65%%\" bgcolor=\"EFE7FC\">\n");
  printf("      <input type=text name=template value=\"%s\" size=40>\n", 
                template);
  printf("    </td>\n");
  printf("  </tr>\n");
  printf("  <tr>\n");
  printf("    <td width=\"35%%\" bgcolor=\"FAE5E6\">\n");
  printf("      <b>How many item one page?</b>\n");
  printf("    </td>\n");
  printf("    <td width=\"65%%\" bgcolor=\"EFE7FC\">\n");
  printf("      <input type=text name=hitPerP value=\"%d\" size=40>\n", 
                hitPerP);
  printf("    </td>\n");
  printf("  </tr>\n");
  printf("  <tr>\n");
  printf("    <td width=\"35%%\" bgcolor=\"FAE5E6\">\n");
  printf("      <p><b>Weight of title</b><br>(score formula)</p>\n");
  printf("    </td>\n");
  printf("    <td width=\"65%%\" bgcolor=\"EFE7FC\">\n"); 
  printf("      <input type=text name=weight value=\"%d\" size=40><br>\n", weight);
  printf("      ex: 10 means score = 5*(10*hit_of_title + hit_of_content).\n");
  printf("    </td>\n");
  printf("  </tr>\n");

  printf("  <tr>\n");
  printf("    <td width=\"35%%\" bgcolor=\"FAE5E6\"><b>Log Client?</b>");
  printf("    </td>\n");
  printf("    <td width=\"65%%\" bgcolor=\"EFE7FC\">\n");
  printf("      <input type=radio name=log value=1 %s>Yes&nbsp;&nbsp; \n",logYes);
  printf("      <input type=radio name=log value=0 %s>No\n", logNo);
  printf("    </td>\n");
  printf("  </tr>\n");

  printf("  <tr>\n");
  printf("    <td width=\"35%%\" bgcolor=\"FAE5E6\"><b>Language version</b>");
  printf("    </td>\n");
  printf("    <td width=\"65%%\" bgcolor=\"EFE7FC\">\n");
  printf("      <input type=radio name=version value=engligh %s>English &nbsp;&nbsp;\n", versionEnglish);
  printf("      <input type=radio name=version value=chinese %s>Chinese\n", versionChinese);
  printf("    </td>\n");
  printf("  </tr>\n");

  printf("  <tr>\n");
  printf("    <td width=\"35%%\" bgcolor=\"FAE5E6\">\n");
  printf("      <b>Homepage Directory</b>\n");
  printf("    </td>\n");
  printf("    <td width=\"65%%\" bgcolor=\"EFE7FC\">\n");
  printf("      <input type=text name=homeDir size=40 value=\"%s\">", homeDir);
  printf("    </td>\n");
  printf("  </tr>\n");

  printf("  <tr>\n");
  printf("    <td width=\"35%%\" bgcolor=\"FAE5E6\">\n");
  printf("      <b>Temp Directory</b>\n");
  printf("    </td>\n");
  printf("    <td width=\"65%%\" bgcolor=\"EFE7FC\">\n");
  printf("      <input type=text name=tempDir size=40 value=\"%s\">", tempDir);
  printf("    </td>\n");
  printf("  </tr>\n");

  printf("  <tr> \n");
  printf("    <td width=\"35%%\" bgcolor=\"FAE5E6\" rowspan=\"2\">\n");
  printf("      <b>HighLight Style</b></td> \n");
  printf("    <td width=\"65%%\" bgcolor=\"EFE7FC\">Color \n");
  printf("      <input type=text name=color size=\"10\" value=\"%s\">", color);
  printf("    </td> \n");
  printf("  </tr> \n");
  printf("  <tr> \n");
  printf("    <td width=\"65%%\" bgcolor=\"EFE7FC\"> \n");
  printf("      <input type=checkbox name=bold %s>Bold \n", bold);
  printf("      <input type=checkbox name=italic %s>Italic </td> \n", italic);
  printf("  </tr> \n");   
  printf("</table><br>\n");

  printf("<table width=590>");
  printf("<tr><td>");
  printf("<div align=\"left\"> \n");
  printf("   <input type=submit name=build value=\" Build \">\n");
  printf("   <input type=reset name=Reset value=\" Reset \">\n"); 
  printf("</div>");
  printf("</td></tr>");
  printf("</table>");
  printf("</form>\n");
  
  printf("<table width=590> \n");
  printf("<tr><td> \n");
  printf("<div align=\"left\"> \n");
  printf("<form action=\"view.cgi\" method=\"POST\" name=\"viewLog\">\n");
  printf("    <input type=hidden name=passwd value=\"%s\">", passwd);
  printf("    <input type=submit name=viewLog value=\"View Client Log\">"); 
  printf("</form> \n");
  printf("</div> \n");
  printf("</td></tr> \n");
  printf("</table> \n");

  printf("</div> \n");
  printf("</body>\n</html>\n");
  
EXIT:
  SQLDisconnect(hdbc);
  SQLFreeConnect(hdbc);
  SQLFreeEnv(henv);
  return;
  
First:
  /*================================================================
   The web administrator logins at the first time, 
   and the program shows the first login-confirming page 
   ================================================================*/
  printf("<body bgcolor=\"f2F8d4\"> \n");
  printf("<div align=\"center\"> \n");

  printf("<script language=\"JavaScript\"> \n");
  printf("function check_both() { \n");
  printf("  var status=true; \n");
  printf("   if (document.check.newPasswd.value != document.check.confirm.value) \n");
  printf("      {alert(\"New Password and Confirm Password are not the same.\"); \n");
  printf("      status=false;} \n");
  printf("  return status; \n");
  printf("}; \n");
  printf("</script> \n");  

  printf("<img src=\"/images/first_up.gif\"> \n");

  printf("<form name=check method=\"POST\" action=\"login.cgi\" "
         " onsubmit=\"return check_both()\">\n");

  printf("<table width=\"100\" border=\"0\" cellpadding=\"5\" cellspacing=\"0\"> \n");
  printf("  <tr bgcolor=\"#dedddd\"> \n");

  printf("     <td>\n");
  printf("     <font size=2 face=\"Arial, Helvetica, sans-serif\">");
  printf("       New Password</font>\n");
  printf("     </td>\n ");
  printf("     <td>\n");
  printf("       <br><input type=password name=newPasswd value=\"%s\" size=13>\n", passwd);
  printf("     </td>\n");
  printf("   </tr>\n");
  printf("   <tr bgcolor=\"#dedddd\">\n");
  printf("     <td>\n");
  printf("     <font size=2 face=\"Arial, Helvetica, sans-serif\">");
  printf("       Confirm Password</font>\n");
  printf("     </td> \n");
  printf("     <td>\n");
  printf("       <input type=password name=confirm value=\"\" size=13>\n");
  printf("     </td>\n");
  printf("   </tr>\n");
  printf("   <tr>\n");
  printf("     <td colspan=\"2\" align=\"center\">\n");
  printf("       <input type=hidden name=ok>");
  printf("       <input type=image src=\"/images/ok.gif\" onclick=\"document.check.submit()\"> ");
  printf("     </td>\n");
  printf("   </tr>\n");
  printf(" </table>\n");

  printf("</form>\n");

  printf("<img src=\"/images/login_bottom.gif\"> \n");  

  printf("</div> \n");

  
  printf("</body></html>\n");  
  return;
  
  
ReType:
  /*==========================================================================
    the web administrator type the wrong password of database, 
    confirm he/she to retype correct password 
    ==========================================================================*/
  printf("<body bgcolor=\"f2F8d4\"> \n");

  printf("<div align=\"center\"> \n");
  printf("<img src=\"/images/login_up.gif\"> \n");


  printf("<form name=\"retype\" action=\"login.cgi\" method=\"POST\"> \n");

  printf("<table width=\"100\" border=\"0\" cellpadding=\"5\" cellspacing=\"0\"> \n");
  printf("  <tr bgcolor=\"#dedddd\"> \n");
  printf("     <td>\n");
  printf("     <font size=2 face=\"Arial, Helvetica, sans-serif\">");
  printf("       Password</font>\n");
  printf("     </td> \n");
  printf("     <td>\n");
  printf("       <input type=password name=passwd value=\"%s\" size=13>\n", passwd);
  printf("     </td>\n");
  printf("   </tr> \n");
  printf("   <tr bgcolor=\"f2F8d4\">  \n");
  printf("     <td colspan=\"2\" align=\"center\">\n");
  printf("       <input type=image name=login src=\"/images/login.gif\" onclick=\"document.retype.submit()\"> ");
  printf("     </td>\n");
  printf("   </tr>\n");
  printf(" </table>\n");

  printf("</form> \n");
  printf("</div>  \n");
  printf("<img src=\"/images/login_bottom.gif\"> \n");
  printf("</body></html> \n");  
  return;
}
