/****************************************************************************
*    Copyright (c) 1999 CASEMaker Inc.                                      *
*    http://www.dbmaker.com  http://www.dbmaker.com.tw                      *
*    You may distribute under the terms of the GNU General Public License.  *
*                                                                           *
*    view.c                                                                 *
*    The cgi program is used to view statistics of Table                    *
*    Log(client search information) and WebPage(inserted html data)         *
*****************************************************************************/
#include "webut.h"
#include "dmwebut.h"

DWitem item[MAX_ITEMS];
int    total_item;

/* static function prototype of view.c */
void static showLog(char *passwd);
void static clearLog(char *passwd);
void static showRecord();

/****************************************************************************
 Main function 
 ****************************************************************************/
void main()
{
  int  i, 
       fgClear=0,       /* whether clear Log of client */
       fgLog=0,         /* whether view Log of cient */
       fgRecord=0;      /* whether view inserted data in database */
  char passwd[LEN_PWD]; /* SYSADM passsword of websearch */
  
  passwd[0]=0;
  
  printf("Content-type: text/html\n\n");
  printf("<html><head>");
  printf("<meta http-equiv=Content-Type content=\"text/html; charset=big5\">\n");
  printf("<title>View Statistics</title>\n");  
  printf("</head><body>");

  DWGetItem();
  
  for (i=0; i<total_item; i++)
    {
    /* The three items below are for viewLog */
    if (strcmp(item[i].name, "passwd")==0)
      strcpy(passwd, item[i].value);
    else if (strcmp(item[i].name, "clear")==0)
      fgClear=1;
    else if (strcmp(item[i].name, "viewLog")==0)
      fgLog=1;
      
    /* The item below is used for viewRecord */
    else if (strcmp(item[i].name, "viewRecord")==0)
      fgRecord=1;
    }  

  if (fgClear)
    clearLog(passwd);
  if (fgLog)
    showLog(passwd);
  if (fgRecord)
    showRecord();  

  printf("</body></html>");
}

/****************************************************************************
 Show Log of client, including when the client search, what pattern word they 
 search, and how many item they got in the search result.
 ****************************************************************************/
static void showLog(
  char *passwd) /* IN password with privilege SYSADM to connect to database */
{
  HENV    henv;
  HDBC    hdbc;
  HSTMT   hstmt;  
  SDWORD  cbopTime;
  SDWORD  cbpattern;
  SDWORD  rc;
  char    opTime[LEN_TIME];     /* operate time of web client */
  char    pattern[LEN_FUPAT];   /* pattern word web client searched */
  char    str1[1000];
  int     got;                  /* got count of search result */

  printf("<form action=\"view.cgi\" METHOD=\"POST\"> \n");
  printf("    <input type=hidden name=\"passwd\" value=\"%s\"> \n", passwd);
  printf("    <input type=submit name=\"clear\" value=\" Clear \"> \n");
  printf("</form><br>\n");
  
  printf("<table width=\"85%%\" border=\"1\"> \n");
  printf("  <tr bgcolor=\"#00CC99\"> \n");
  printf("    <td><font size=4 face=\"Arial, Helvetica, sans-serif\"> "
         "        Time</font></td> \n");
  printf("    <td><font size=4 face=\"Arial, Helvetica, sans-serif\"> "
         "        Search Pattern</font></td> \n");
  printf("    <td><font size=4 face=\"Arial, Helvetica, sans-serif\"> "
         "        Got</font></td> \n");
  printf("  </tr> \n");

  if (SQLAllocEnv(&henv))
    printf("allocate envrionment handle fail !! \n");
  if (SQLAllocConnect(henv,&hdbc))
    printf("allocate connection handle fail !! \n");

  /*=== Connect to Database DBNAME ===*/
  SQLConnect(hdbc, (UCHAR *)DBNAME, SQL_NTS, (UCHAR *)"SYSADM", 
             SQL_NTS, (UCHAR *)passwd, SQL_NTS);  
  checkrc(RTN_OK, henv, hdbc, NULL);  
  SQLSetConnectOption(hdbc, SQL_AUTOCOMMIT, SQL_AUTOCOMMIT_OFF);
  checkrc(RTN_OK, henv, hdbc, NULL);  
  SQLAllocStmt(hdbc,&hstmt);
  checkrc(RTN_OK, henv, hdbc, hstmt);  

  sprintf(str1, "select opTime, pattern, got from Log order by got DESC");
  SQLExecDirect(hstmt, (UCHAR *)str1, SQL_NTS);
  checkrc(RTN_OK, henv, hdbc, hstmt);  

  SQLBindCol(hstmt, 1, SQL_C_CHAR,  opTime,  LEN_TIME, &cbopTime);
  checkrc(RTN_OK, henv, hdbc, hstmt);  
  SQLBindCol(hstmt, 2, SQL_C_CHAR, pattern, LEN_FUPAT, &cbpattern);
  checkrc(RTN_OK, henv, hdbc, hstmt);  
  SQLBindCol(hstmt, 3, SQL_C_LONG, &got,      0, NULL);
  checkrc(RTN_OK, henv, hdbc, hstmt);  
    
  while (TRUE)
    {
    rc=SQLFetch(hstmt);
    if (rc==SQL_SUCCESS || rc==SQL_SUCCESS_WITH_INFO)
      {
      printf("  <tr bgcolor=\"#FFFFCC\">  \n");
      printf("    <td>%s</td> \n", opTime);
      printf("    <td>%s</td> \n", pattern);
      printf("    <td>%d</td> \n", got);
      printf("  </tr>  \n");
      }
    else 
      {
      if (rc==SQL_NO_DATA_FOUND)
        break;      
      else checkrc(RTN_OK, henv, hdbc, hstmt); 
      }
    }
    
  SQLFreeStmt(hstmt, SQL_DROP);
  checkrc(RTN_OK, henv, hdbc, hstmt);   

  printf("</table> \n");
EXIT:
  SQLDisconnect(hdbc);
  SQLFreeConnect(hdbc);
  SQLFreeEnv(henv);
}

/****************************************************************************
 Clear up Log of client.(In other word, delete all values in table Log.)
 ****************************************************************************/
static void clearLog(
  char *passwd) /* IN password with privilege SYSADM to connect to database */
{
  HENV    henv;
  HDBC    hdbc;
  HSTMT   hstmt;  
  char    str1[1000];

  if (SQLAllocEnv(&henv))
    printf("allocate envrionment handle fail !! \n");
  if (SQLAllocConnect(henv,&hdbc))
    printf("allocate connection handle fail !! \n");

  /*=== Connect to Database DBNAME ===*/
  SQLConnect(hdbc, (UCHAR *)DBNAME, SQL_NTS, (UCHAR *)"SYSADM", 
             SQL_NTS, (UCHAR *)passwd, SQL_NTS);  
  checkrc(RTN_OK, henv, hdbc, NULL);  
  SQLSetConnectOption(hdbc, SQL_AUTOCOMMIT, SQL_AUTOCOMMIT_OFF);
  checkrc(RTN_OK, henv, hdbc, NULL);  
  SQLAllocStmt(hdbc,&hstmt);
  checkrc(RTN_OK, henv, hdbc, hstmt);  

  sprintf(str1, "delete from Log");
  SQLExecDirect(hstmt, (UCHAR *)str1, SQL_NTS);
  checkrc(RTN_OK, henv, hdbc, hstmt);

  /*=== Produce a commit operation ===*/
  SQLTransact(henv, hdbc, SQL_COMMIT);
  checkrc(RTN_OK, henv, hdbc, hstmt);
  
  printf("<font color=\"red\"> <h3> Clear Client Log OK </h3></font>");
    
EXIT:
  SQLDisconnect(hdbc);
  SQLFreeConnect(hdbc);
  SQLFreeEnv(henv);
}

/****************************************************************************
 Show record of inserted data in table WabPage to see their serial number,
 title of content, and full path of file location.
 ****************************************************************************/
static void showRecord()
{
  HENV    henv;
  HDBC    hdbc;
  HSTMT   hstmt;  
  SDWORD  cbtitle;    /* character count of title */
  SDWORD  cbfilename; /* character count of filename */
  SDWORD  rc;
  char    title[LEN_TITLE];     /* title of html file */
  char    filename[LEN_FNAME];  /* filename of html file */
  char    str1[1000];       
  int     num;                  /* serial number of inserted data */

  printf("<table width=\"100%%\" border=\"1\"> \n");
  printf("  <tr bgcolor=\"#00CC99\"> \n");
  printf("    <td width=\"4%%\"><font size=4 face=\"Arial, Helvetica, sans-serif\"> "
         "        No.</font></td> \n");
  printf("    <td width=\"35%%\"><font size=4 face=\"Arial, Helvetica, sans-serif\"> "
         "        Title</font></td> \n");
  printf("    <td width=\"61%%\"><font size=4 face=\"Arial, Helvetica, sans-serif\"> "
         "        FileName</font></td> \n");
  printf("  </tr> \n");

  if (SQLAllocEnv(&henv))
    printf("allocate envrionment handle fail !! \n");
  if (SQLAllocConnect(henv,&hdbc))
    printf("allocate connection handle fail !! \n");

  /*=== Connect to Database DBNAME ===*/
  SQLConnect(hdbc, (UCHAR *)DBNAME, SQL_NTS, (UCHAR *)"guest", 
             SQL_NTS, (UCHAR *)"", SQL_NTS);
  checkrc(RTN_OK, henv, hdbc, NULL);  
  SQLSetConnectOption(hdbc, SQL_AUTOCOMMIT, SQL_AUTOCOMMIT_OFF);
  checkrc(RTN_OK, henv, hdbc, NULL);  
  SQLAllocStmt(hdbc,&hstmt);
  checkrc(RTN_OK, henv, hdbc, hstmt);  

  sprintf(str1, "select num, title, filename(fobj) from SYSADM.WebPage order by num");
  SQLExecDirect(hstmt, (UCHAR *)str1, SQL_NTS);
  checkrc(RTN_OK, henv, hdbc, hstmt);

  SQLBindCol(hstmt, 1, SQL_C_LONG,     &num,          0, NULL);
  checkrc(RTN_OK, henv, hdbc, hstmt);
  SQLBindCol(hstmt, 2, SQL_C_CHAR,    title,  LEN_TITLE, &cbtitle);
  checkrc(RTN_OK, henv, hdbc, hstmt);
  SQLBindCol(hstmt, 3, SQL_C_CHAR, filename,  LEN_FNAME, &cbfilename);
  checkrc(RTN_OK, henv, hdbc, hstmt);

  while (TRUE)
    {
    rc=SQLFetch(hstmt);
    if (rc==SQL_SUCCESS || rc==SQL_SUCCESS_WITH_INFO)
      {
      printf("  <tr bgcolor=\"#FFFFCC\">  \n");
      printf("    <td><b>%d</b></td> \n", num);
      printf("    <td>%s</td> \n", title);
      printf("    <td>%s</td> \n", filename);
      printf("  </tr>  \n");
      }
    else 
      {
      if (rc==SQL_NO_DATA_FOUND)
        break;      
      else checkrc(RTN_OK, henv, hdbc, hstmt); 
      }
    }
  SQLFreeStmt(hstmt, SQL_DROP);
  checkrc(RTN_OK, henv, hdbc, hstmt);   

  printf("</table> \n");
EXIT:
  SQLDisconnect(hdbc);
  SQLFreeConnect(hdbc);
  SQLFreeEnv(henv);
}

