create db websearch;

create table Path(type varchar(10), path varchar(80));
create table WebPage(num int, title varchar(1000), \
                     content long varchar, fobj file, ftime timestamp);
create table Log(opTime timestamp, pattern varchar(200), got int) \
		lock mode row;
create table Output(header long varchar, footer long varchar);
create table Params(name varchar(10), chValue varchar(30), intValue int);

create table mapText(name varchar(10), language varchar(10), display varchar(50));
insert into mapText values(?, ?, ?);
'NONE', 'chinese', 'dL';
'TOOMANY', 'chinese', 'doƹLhAмW[d߱';
'PAGE', 'chinese', '';
'ITEMS', 'chinese','';
'PIPATTERN','chinese','пJdߦrA¡I';
'PATTERN','chinese','dߦrG';
'REQUERY','chinese','i@Bd';
'ONE','chinese','Ĥ@';
'PREV','chinese','W@';
'NEXT','chinese','U@';
'LAST','chinese','̥';
'SCORE', 'chinese','ơG';

'NONE', 'english', 'No data found.';
'TOOMANY', 'english', 'To many data found, please add more condition for search.';
'PAGE', 'english', 'Page';
'ITEMS', 'english','Item';
'PIPATTERN','english','Please input search pattern, thanks!';
'PATTERN','english','Search Pattern:';
'REQUERY','english','ReQuery';
'ONE','english','First';
'PREV','english','< Prev ';
'NEXT','english','Next >';
'LAST','english','Last';
'SCORE', 'english','Score:';
end;

create function libmedia.PureText(long varbinary) returns long varchar;

create function libtext.HIGHLIGHT(long varchar,varchar(512),int, \
    varchar(100),varchar(100)) RETURNS LONG VARCHAR;
create function libtext.HITCOUNT(long varchar,varchar(512),int) RETURNS INT;
create function libtext.HITPOS(long varchar,varchar(512),int,int,int) RETURNS INT;
create function libtext.BLOBLEN(long varbinary) RETURNS INT;
create function libtext.HTMLTITLE(long varchar) RETURNS VARCHAR(1000);

grant CONNECT to guest;
grant select on WebPage to guest;
grant select, insert on Log to guest;
grant select on mapText to guest;
grant select on Path to guest;
grant select on Output to guest;
grant select, insert on Params to guest;

disconnect;
q;